; Script generated by the HM NIS Edit Script Wizard.

; HM NIS Edit Wizard helper defines
!define PRODUCT_NAME "LPHP-Engine"
!define PRODUCT_VERSION "1.0.0"
!define PRODUCT_PUBLISHER "Endev"
!define PRODUCT_WEB_SITE "https://endev.at/p/lphp"
!define PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\LPHPConsole.exe"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"

SetCompressor lzma

; MUI 1.67 compatible ------
!include "MUI.nsh"

; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "lphp.ico"
!define MUI_UNICON "uninst.ico"

; Welcome page
!insertmacro MUI_PAGE_WELCOME
; License page
!insertmacro MUI_PAGE_LICENSE "LICENSE"
; Directory page
!insertmacro MUI_PAGE_DIRECTORY
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Finish page
!define MUI_FINISHPAGE_RUN "$INSTDIR\LPHPUI.exe"
!insertmacro MUI_PAGE_FINISH

; Uninstaller pages
!insertmacro MUI_UNPAGE_INSTFILES

; Language files
!insertmacro MUI_LANGUAGE "English"

; Reserve files
!insertmacro MUI_RESERVEFILE_INSTALLOPTIONS

; MUI end ------

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "LPHP_Setup.exe"
InstallDir "$PROGRAMFILES\Endev\LPHP-Engine"
InstallDirRegKey HKLM "${PRODUCT_DIR_REGKEY}" ""
ShowInstDetails show
ShowUnInstDetails show

Section "LPHP_Console" SEC01
  SetOutPath "$INSTDIR"
  SetOverwrite try
  File "LPHP-Engine\LPHPConsole\bin\Release\LPHPConsole.exe"
  CreateDirectory "$SMPROGRAMS\LPHP"
  CreateShortCut "$SMPROGRAMS\LPHP\LPHP Console.lnk" "$INSTDIR\LPHPConsole.exe"
  CreateShortCut "$DESKTOP\LPHP Console.lnk" "$INSTDIR\LPHPConsole.exe"
  File "LPHP-Engine\LPHPConsole\bin\Release\LPHPCore.dll"
SectionEnd

Section "LPHP_UI" SEC02
  File "LPHP-Engine\LPHPUI\bin\Release\EnvDTE.dll"
  File "LPHP-Engine\LPHPUI\bin\Release\LPHPCore.dll"
  File "LPHP-Engine\LPHPUI\bin\Release\LPHPUI.exe"
  CreateShortCut "$SMPROGRAMS\LPHP\LPHP UI.lnk" "$INSTDIR\LPHPUI.exe"
  CreateShortCut "$DESKTOP\LPHP UI.lnk" "$INSTDIR\LPHPUI.exe"
  File "LPHP-Engine\LPHPUI\bin\Release\LPHP_Logo.png"
  File "LPHP-Engine\LPHPUI\bin\Release\stdole.dll"
  File "LPHP-Engine\LPHPUI\bin\Release\Syncfusion.Grid.Base.dll"
  File "LPHP-Engine\LPHPUI\bin\Release\Syncfusion.Grid.Windows.dll"
  File "LPHP-Engine\LPHPUI\bin\Release\Syncfusion.Grid.Windows.XmlSerializers.dll"
  File "LPHP-Engine\LPHPUI\bin\Release\Syncfusion.Shared.Base.dll"
  File "LPHP-Engine\LPHPUI\bin\Release\Syncfusion.Shared.Windows.dll"
  File "LPHP-Engine\LPHPUI\bin\Release\Syncfusion.SpellChecker.Base.dll"
  File "LPHP-Engine\LPHPUI\bin\Release\Syncfusion.Tools.Base.dll"
  File "LPHP-Engine\LPHPUI\bin\Release\Syncfusion.Tools.Windows.dll"
SectionEnd

Section -AdditionalIcons
  WriteIniStr "$INSTDIR\${PRODUCT_NAME}.url" "InternetShortcut" "URL" "${PRODUCT_WEB_SITE}"
  CreateShortCut "$SMPROGRAMS\LPHP\Website.lnk" "$INSTDIR\${PRODUCT_NAME}.url"
  CreateShortCut "$SMPROGRAMS\LPHP\Uninstall.lnk" "$INSTDIR\uninst.exe"
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\uninst.exe"
  WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "" "$INSTDIR\LPHPConsole.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\LPHPConsole.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
SectionEnd


Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "$(^Name) was removed from your PC successfully!"
FunctionEnd

Function un.onInit
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Do you want to remove $(^Name) and all of its components?" IDYES +2
  Abort
FunctionEnd

Section Uninstall
  Delete "$INSTDIR\${PRODUCT_NAME}.url"
  Delete "$INSTDIR\uninst.exe"
  Delete "$INSTDIR\Syncfusion.Tools.Windows.dll"
  Delete "$INSTDIR\Syncfusion.Tools.Base.dll"
  Delete "$INSTDIR\Syncfusion.SpellChecker.Base.dll"
  Delete "$INSTDIR\Syncfusion.Shared.Windows.dll"
  Delete "$INSTDIR\Syncfusion.Shared.Base.dll"
  Delete "$INSTDIR\Syncfusion.Grid.Windows.XmlSerializers.dll"
  Delete "$INSTDIR\Syncfusion.Grid.Windows.dll"
  Delete "$INSTDIR\Syncfusion.Grid.Base.dll"
  Delete "$INSTDIR\stdole.dll"
  Delete "$INSTDIR\LPHP_Logo.png"
  Delete "$INSTDIR\LPHPUI.exe"
  Delete "$INSTDIR\LPHPCore.dll"
  Delete "$INSTDIR\EnvDTE.dll"
  Delete "$INSTDIR\LPHPConsole.exe"

  Delete "$SMPROGRAMS\LPHP\Uninstall.lnk"
  Delete "$SMPROGRAMS\LPHP\Website.lnk"
  Delete "$DESKTOP\LPHP UI.lnk"
  Delete "$SMPROGRAMS\LPHP\LPHP UI.lnk"
  Delete "$DESKTOP\LPHP Console.lnk"
  Delete "$SMPROGRAMS\LPHP\LPHP Console.lnk"

  RMDir "$SMPROGRAMS\LPHP"
  RMDir "$INSTDIR"

  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  DeleteRegKey HKLM "${PRODUCT_DIR_REGKEY}"
  SetAutoClose true
SectionEnd